(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("password-generator"), require("material-ui/RaisedButton"), require("material-ui/styles/colors"), require("material-ui/TextField"), require("material-ui/Dialog"), require("material-ui/LinearProgress"), require("material-ui/Slider"), require("material-ui/svg-icons/content/content-copy"), require("material-ui/svg-icons/content/clear"), require("material-ui/svg-icons/content/save"), require("material-ui/svg-icons/notification/priority-high"), require("material-ui/FlatButton"), require("material-ui/Snackbar"), require("material-ui/IconButton"), require("material-ui/Toggle"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "password-generator", "material-ui/RaisedButton", "material-ui/styles/colors", "material-ui/TextField", "material-ui/Dialog", "material-ui/LinearProgress", "material-ui/Slider", "material-ui/svg-icons/content/content-copy", "material-ui/svg-icons/content/clear", "material-ui/svg-icons/content/save", "material-ui/svg-icons/notification/priority-high", "material-ui/FlatButton", "material-ui/Snackbar", "material-ui/IconButton", "material-ui/Toggle"], factory);
	else if(typeof exports === 'object')
		exports["PasswordGenerator"] = factory(require("react"), require("password-generator"), require("material-ui/RaisedButton"), require("material-ui/styles/colors"), require("material-ui/TextField"), require("material-ui/Dialog"), require("material-ui/LinearProgress"), require("material-ui/Slider"), require("material-ui/svg-icons/content/content-copy"), require("material-ui/svg-icons/content/clear"), require("material-ui/svg-icons/content/save"), require("material-ui/svg-icons/notification/priority-high"), require("material-ui/FlatButton"), require("material-ui/Snackbar"), require("material-ui/IconButton"), require("material-ui/Toggle"));
	else
		root["PasswordGenerator"] = factory(root["react"], root["password-generator"], root["material-ui/RaisedButton"], root["material-ui/styles/colors"], root["material-ui/TextField"], root["material-ui/Dialog"], root["material-ui/LinearProgress"], root["material-ui/Slider"], root["material-ui/svg-icons/content/content-copy"], root["material-ui/svg-icons/content/clear"], root["material-ui/svg-icons/content/save"], root["material-ui/svg-icons/notification/priority-high"], root["material-ui/FlatButton"], root["material-ui/Snackbar"], root["material-ui/IconButton"], root["material-ui/Toggle"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__, __WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_4__, __WEBPACK_EXTERNAL_MODULE_5__, __WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_7__, __WEBPACK_EXTERNAL_MODULE_8__, __WEBPACK_EXTERNAL_MODULE_9__, __WEBPACK_EXTERNAL_MODULE_10__, __WEBPACK_EXTERNAL_MODULE_11__, __WEBPACK_EXTERNAL_MODULE_12__, __WEBPACK_EXTERNAL_MODULE_13__, __WEBPACK_EXTERNAL_MODULE_14__, __WEBPACK_EXTERNAL_MODULE_15__, __WEBPACK_EXTERNAL_MODULE_16__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _passwordGenerator = __webpack_require__(2);

	var _passwordGenerator2 = _interopRequireDefault(_passwordGenerator);

	var _RaisedButton = __webpack_require__(3);

	var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

	var _colors = __webpack_require__(4);

	var _TextField = __webpack_require__(5);

	var _TextField2 = _interopRequireDefault(_TextField);

	var _Dialog = __webpack_require__(6);

	var _Dialog2 = _interopRequireDefault(_Dialog);

	var _LinearProgress = __webpack_require__(7);

	var _LinearProgress2 = _interopRequireDefault(_LinearProgress);

	var _Slider = __webpack_require__(8);

	var _Slider2 = _interopRequireDefault(_Slider);

	var _contentCopy = __webpack_require__(9);

	var _contentCopy2 = _interopRequireDefault(_contentCopy);

	var _clear = __webpack_require__(10);

	var _clear2 = _interopRequireDefault(_clear);

	var _save = __webpack_require__(11);

	var _save2 = _interopRequireDefault(_save);

	var _priorityHigh = __webpack_require__(12);

	var _priorityHigh2 = _interopRequireDefault(_priorityHigh);

	var _FlatButton = __webpack_require__(13);

	var _FlatButton2 = _interopRequireDefault(_FlatButton);

	var _Snackbar = __webpack_require__(14);

	var _Snackbar2 = _interopRequireDefault(_Snackbar);

	var _IconButton = __webpack_require__(15);

	var _IconButton2 = _interopRequireDefault(_IconButton);

	var _Toggle = __webpack_require__(16);

	var _Toggle2 = _interopRequireDefault(_Toggle);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
	                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by jpicado on 15/07/16.
	                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

	var maxLength = 18;
	var minLength = 12;
	var uppercaseMinCount = 3;
	var lowercaseMinCount = 3;
	var numberMinCount = 2;
	var specialMinCount = 2;
	var UPPERCASE_RE = /([A-Z])/g;
	var LOWERCASE_RE = /([a-z])/g;
	var NUMBER_RE = /([\d])/g;
	var SPECIAL_CHAR_RE = /([\?\-])/g;
	var NON_REPEATING_CHAR_RE = /([\w\d\?\-])\1{2,}/g;

	var styles = {
	    container: {
	        textAlign: 'center',
	        paddingTop: 40
	    },
	    block: {
	        maxWidth: 250,
	        textAlign: 'left',
	        margin: '0 auto'
	    },
	    input: {
	        textAlign: 'center',
	        padding: 20,
	        fontWeight: 'bolder',
	        fontSize: '2em'
	    },
	    sliders: {
	        padding: '0px 45px',
	        paddingTop: 10
	    },
	    label: {
	        padding: '0px 25px',
	        fontSize: '2em'
	    },
	    password: {
	        color: 'black',
	        fontSize: 18,
	        textAlign: 'center'
	    },
	    dialog_text: {
	        color: 'black',
	        fontSize: 16,
	        width: '100%',
	        textAlign: 'center'
	    },
	    save_text: {
	        color: 'black',
	        fontSize: 16,
	        width: '100%',
	        textAlign: 'center'
	    },
	    toggle: {
	        marginBottom: 16
	    }
	};

	var PasswordInput = function (_Component) {
	    _inherits(PasswordInput, _Component);

	    function PasswordInput(props) {
	        _classCallCheck(this, PasswordInput);

	        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(PasswordInput).call(this, props));

	        _this.state = {
	            open: false,
	            completed: _this.scorePassword(props.password),
	            dialog: false
	        };
	        return _this;
	    }

	    _createClass(PasswordInput, [{
	        key: 'handleRequestClose',
	        value: function handleRequestClose() {
	            this.setState({
	                open: false
	            });
	        }
	    }, {
	        key: 'copy',
	        value: function copy() {
	            cordova.plugins.clipboard.copy(this.props.password);
	            this.setState({
	                open: true
	            });
	        }
	    }, {
	        key: 'shouldComponentUpdate',
	        value: function shouldComponentUpdate() {
	            var score = this.scorePassword(this.props.password);
	            this.setState({
	                completed: score
	            });
	            return true;
	        }
	    }, {
	        key: 'scorePassword',
	        value: function scorePassword(pass) {
	            var score = 0;
	            if (!pass) return score;

	            // award every unique letter until 5 repetitions
	            var letters = new Object();
	            for (var i = 0; i < pass.length; i++) {
	                letters[pass[i]] = (letters[pass[i]] || 0) + 1;
	                score += 5.0 / letters[pass[i]];
	            }

	            // bonus points for mixing it up
	            var variations = {
	                digits: /\d/.test(pass),
	                lower: /[a-z]/.test(pass),
	                upper: /[A-Z]/.test(pass),
	                nonWords: /\W/.test(pass)
	            };

	            var variationCount = 0;
	            for (var check in variations) {
	                variationCount += variations[check] == true ? 1 : 0;
	            }
	            score += (variationCount - 1) * 10;
	            console.log(score);
	            return parseInt(score);
	        }
	    }, {
	        key: 'save',
	        value: function save() {
	            this.setState({
	                dialog: true,
	                label: ""
	            });
	        }
	    }, {
	        key: 'handleClose',
	        value: function handleClose() {
	            var label = this.state.label;
	            localStorage.setItem(label, this.props.password);
	            this.closeDialog();
	            this.props.clean();
	        }
	    }, {
	        key: 'closeDialog',
	        value: function closeDialog() {
	            this.setState({
	                dialog: false,
	                label: ""
	            });
	        }
	    }, {
	        key: 'handleCancel',
	        value: function handleCancel() {
	            this.closeDialog();
	        }
	    }, {
	        key: 'handleChange',
	        value: function handleChange(event) {
	            this.setState({
	                label: event.target.value
	            });
	        }
	    }, {
	        key: 'render',
	        value: function render() {
	            var actions = [_react2.default.createElement(_FlatButton2.default, {
	                label: 'Save',
	                primary: true,
	                keyboardFocused: true,
	                onTouchTap: this.handleClose.bind(this)
	            }), _react2.default.createElement(_FlatButton2.default, {
	                label: 'Cancel',
	                primary: false,
	                keyboardFocused: true,
	                onTouchTap: this.handleCancel.bind(this)
	            })];
	            var styles_dialog = styles.dialog_text;
	            if (this.props.password.length >= 18) {
	                styles_dialog.fontSize = 12;
	            }
	            return _react2.default.createElement(
	                'div',
	                null,
	                _react2.default.createElement(
	                    'div',
	                    null,
	                    _react2.default.createElement(_TextField2.default, {
	                        disabled: true,
	                        id: 'text-field-controlled',
	                        inputStyle: styles.password,
	                        fullWidth: false,
	                        underlineShow: false,
	                        value: this.props.password
	                    }),
	                    _react2.default.createElement(_Snackbar2.default, {
	                        open: this.state.open,
	                        message: 'Password copied to the clipboard',
	                        autoHideDuration: 4000
	                    }),
	                    _react2.default.createElement(_LinearProgress2.default, { mode: 'determinate', value: this.state.completed })
	                ),
	                _react2.default.createElement(
	                    'div',
	                    null,
	                    _react2.default.createElement(
	                        _IconButton2.default,
	                        { touch: false,
	                            tooltipPosition: 'top-left',
	                            onTouchTap: this.copy.bind(this) },
	                        _react2.default.createElement(_contentCopy2.default, null)
	                    ),
	                    _react2.default.createElement(
	                        _IconButton2.default,
	                        { touch: false,
	                            tooltipPosition: 'top-left',
	                            onTouchTap: this.props.clean,
	                            tooltip: 'Clean' },
	                        _react2.default.createElement(_clear2.default, null)
	                    ),
	                    _react2.default.createElement(
	                        _IconButton2.default,
	                        { touch: false,
	                            tooltipPosition: 'top-left',
	                            onTouchTap: this.save.bind(this),
	                            tooltip: 'Save' },
	                        _react2.default.createElement(_save2.default, null)
	                    ),
	                    _react2.default.createElement(
	                        _Dialog2.default,
	                        {
	                            title: 'Save Password',
	                            actions: actions,
	                            modal: false,
	                            open: this.state.dialog,
	                            onRequestClose: this.handleClose.bind(this) },
	                        _react2.default.createElement(_TextField2.default, {
	                            disabled: true,
	                            id: 'text-field-controlled',
	                            inputStyle: styles_dialog,
	                            style: styles.dialog_text,
	                            underlineStyle: styles.dialog_text,
	                            textareaStyle: styles.dialog_text,
	                            underlineDisabledStyle: styles.dialog_text,
	                            underlineShow: false,
	                            fullWidth: false,
	                            value: this.props.password
	                        }),
	                        _react2.default.createElement(_TextField2.default, {
	                            disabled: false,
	                            id: 'text-field-label',
	                            onChange: this.handleChange.bind(this),
	                            style: styles.save_text,
	                            value: this.state.label
	                        }),
	                        _react2.default.createElement(
	                            'div',
	                            null,
	                            _react2.default.createElement(_priorityHigh2.default, null),
	                            ' This will save password locally and non encrypted.'
	                        )
	                    )
	                )
	            );
	        }
	    }]);

	    return PasswordInput;
	}(_react.Component);

	var Password = function () {
	    function Password(randomLength) {
	        _classCallCheck(this, Password);

	        this.randomLength = randomLength || 8;
	    }

	    _createClass(Password, [{
	        key: 'customPassword',
	        value: function customPassword() {
	            var password = (0, _passwordGenerator2.default)(this.randomLength, false, /[\w\d\?\-]/);
	            return password;
	        }
	    }]);

	    return Password;
	}();

	var PasswordGeneratorApp = function (_Component2) {
	    _inherits(PasswordGeneratorApp, _Component2);

	    function PasswordGeneratorApp() {
	        _classCallCheck(this, PasswordGeneratorApp);

	        var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(PasswordGeneratorApp).call(this));

	        _this2.state = {
	            password: "",
	            complexity: 0.5
	        };
	        return _this2;
	    }

	    _createClass(PasswordGeneratorApp, [{
	        key: 'launchPassword',
	        value: function launchPassword(event) {
	            this.generateNewPassword(8);
	        }
	    }, {
	        key: 'generateNewPassword',
	        value: function generateNewPassword(maxLength) {
	            var password = new Password(maxLength);
	            var textPass = password.customPassword();
	            this.changePassword(textPass);
	        }
	    }, {
	        key: 'changePassword',
	        value: function changePassword(password) {
	            this.setState({
	                password: password
	            });
	        }
	    }, {
	        key: 'clean',
	        value: function clean() {
	            this.changePassword("");
	        }
	    }, {
	        key: 'changeComplexity',
	        value: function changeComplexity(event, complexity) {
	            var c = complexity * 25;
	            this.generateNewPassword(c);
	        }
	    }, {
	        key: 'render',
	        value: function render() {
	            var input = _react2.default.createElement('span', null);
	            if (this.state.password != "") {
	                input = _react2.default.createElement(
	                    'div',
	                    null,
	                    _react2.default.createElement(PasswordInput, {
	                        clean: this.clean.bind(this),
	                        password: this.state.password }),
	                    _react2.default.createElement(
	                        'div',
	                        { style: styles.sliders },
	                        _react2.default.createElement(_Slider2.default, { name: 'strong',
	                            description: 'How strong you need the password?',
	                            onChange: this.changeComplexity.bind(this),
	                            value: this.state.complexity,
	                            min: 0.1,
	                            defaultValue: 0.5 })
	                    ),
	                    _react2.default.createElement(
	                        'div',
	                        { style: styles.block },
	                        _react2.default.createElement(_Toggle2.default, {
	                            label: 'Include Numbers',
	                            style: styles.toggle
	                        }),
	                        _react2.default.createElement(_Toggle2.default, {
	                            label: 'Include Uppercase',
	                            defaultToggled: true,
	                            style: styles.toggle
	                        }),
	                        _react2.default.createElement(_Toggle2.default, {
	                            label: 'Ambiguous Characters',
	                            style: styles.toggle
	                        }),
	                        _react2.default.createElement(_Toggle2.default, {
	                            label: 'ASCII Characters',
	                            defaultToggled: true,
	                            style: styles.toggle
	                        })
	                    )
	                );
	            } else {
	                input = _react2.default.createElement(
	                    'div',
	                    null,
	                    _react2.default.createElement(_RaisedButton2.default, {
	                        label: 'Generate Password',
	                        secondary: true,
	                        onTouchTap: this.launchPassword.bind(this)
	                    })
	                );
	            }
	            return _react2.default.createElement(
	                'div',
	                null,
	                _react2.default.createElement(
	                    'div',
	                    { style: styles.container },
	                    input
	                )
	            );
	        }
	    }]);

	    return PasswordGeneratorApp;
	}(_react.Component);

	exports.default = PasswordGeneratorApp;

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ },
/* 4 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_4__;

/***/ },
/* 5 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_5__;

/***/ },
/* 6 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ },
/* 7 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ },
/* 8 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_8__;

/***/ },
/* 9 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_9__;

/***/ },
/* 10 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_10__;

/***/ },
/* 11 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_11__;

/***/ },
/* 12 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_12__;

/***/ },
/* 13 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_13__;

/***/ },
/* 14 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_14__;

/***/ },
/* 15 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_15__;

/***/ },
/* 16 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_16__;

/***/ }
/******/ ])
});
;